/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#include <sys/bios.h>
#include <sys/libwwc.h>

#include "wwgsub.h"

#include "bsvilwp.h" /* BMPSaver IL */

#include "display.h"

#define VIEW_X_OFFSET	32
#define VIEW_Y_OFFSET	24

#include "resutils.h"

/*
 * mkfent ̐Ń\[X 16܂
 */

/* ================ */
/*  \[X ID     */
/* ================ */

#define RES_BMPID_ICON		0
#define RES_BMPID_FEDORA	1
#define RES_BMPID_GAMEOVER	2
#define RES_BMPID_WINNING	3
#define RES_BMPID_TITLE		4
#define RES_BMPID_YASUOKA	5
#define RES_BMPID_SCORE		6
#define RES_BMPID_HISCORE	7
#define RES_BMPID_KEYIMG	8
#define RES_BMPID_KEYDESC	9
#define RES_BMPID_NUMBER	10
#define RES_BMPID_4X4FONT	11
#define RES_BMPID_KEYIMG2	12
#define RES_BMPID_KEYDESC2	13
#define RES_BMPID_CANNON	14

#define RES_BMPID_MAX		14	/* ID ̍őlƈv邱 */

static char far *s_res_table[RES_BMPID_MAX+1];

int fed_dsp_load_resources()
{
	res_t far *resp;
	int i;

	for (i = 0; i <= RES_BMPID_MAX; i++) {
		s_res_table[i] = ww_find_bmp_resource(i);
	}

	/* 4x4 tHg̐ݒ */
	ww_4x4_initfont(s_res_table[RES_BMPID_4X4FONT]);

	return 0;
}

void fed_dsp_on()
{
	/* LCD _ */
	lcd_set_sleep(1);
}

void fed_dsp_off()
{
	/* LCD  */
	lcd_set_sleep(0);
}

void fed_dsp_cls()
{
	ww_g_cls(0);

	/*  */
	ww_g_init(SCREEN1, 5);
	ww_g_init(SCREEN2, 4);
}

void fed_dsp_line(int x1, int y1, int x2, int y2)
{
	ww_g_line(x1,y1, x2,y2, 3);
}

int fed_dsp_init_palette()
{
	/* pbg */
	if (wwc_get_hardarch() == HARDARCH_WS) {
		int i;
		/*
		 * LCDKf[^
		 */
		lcd_set_color(0x7530, 0xfdb9);

		/*
		 * ftHgpbgݒ
		 */
		for (i = 0; i <= 15; i++) {
			palette_set_color(i, 0x7530);
		}

		/* SCREEN1 ̐F́CÂ */
		palette_set_color(FED_COLOR_SCREEN1, 0x3210);

		/* ÂFݒ */
		palette_set_color(FED_COLOR_WHITE_DARK,		0x4320);
		palette_set_color(FED_COLOR_GREEN_DARK,		0x4320);
		palette_set_color(FED_COLOR_MAGENTA_DARK,	0x4320);
		palette_set_color(FED_COLOR_CYAN_DARK,		0x4320);
		palette_set_color(FED_COLOR_YELLOW_DARK,	0x4320);

		/*
		 * FEDORA XvCgp̃pbgݒ
		 */
		palette_set_color(FEDORA_COLOR, 0x7530);

		/*
		 * TRILBY XvCgp̃pbgݒ
		 */
		palette_set_color(TRILBY_COLOR, 0x6420);

		/*
		 * CANNON XvCgp̃pbgݒ
		 */
		palette_set_color(CANNON_COLOR, 0x7530);

	} else {
		int i;

		/*
		 * 4 FJ[[hɐݒ
		 */
		wwc_set_color_mode(COLOR_MODE_4COLOR);

		/*
		 * ftHgpbgݒ
		 */
		for (i = 0; i <= 15; i++) {
			wwc_palette_set_color(i, 0, 0x0000);	/*  */
			wwc_palette_set_color(i, 1, 0x0f3f);	/*  */
			wwc_palette_set_color(i, 2, 0x03f3);	/*  */
			wwc_palette_set_color(i, 3, 0x03ff);	/* F */
		}

		/* SCREEN1 ̐F́CÂ */
		wwc_palette_set_color(FED_COLOR_SCREEN1, 0, 0x0000);		/*  */
		wwc_palette_set_color(FED_COLOR_SCREEN1, 1, 0x0818);		/*  */
		wwc_palette_set_color(FED_COLOR_SCREEN1, 2, 0x0181);		/*  */
		wwc_palette_set_color(FED_COLOR_SCREEN1, 3, 0x0188);		/* F */

		wwc_palette_set_color(FED_COLOR_WHITE,		3, 0x0fff);	/*  */
		wwc_palette_set_color(FED_COLOR_GREEN,		3, 0x03f3);	/*  */
		wwc_palette_set_color(FED_COLOR_MAGENTA,	3, 0x0f3f);	/*  */
		wwc_palette_set_color(FED_COLOR_CYAN,		3, 0x03ff);	/*  */
		wwc_palette_set_color(FED_COLOR_YELLOW,		3, 0x0ff3);	/*  */

		wwc_palette_set_color(FED_COLOR_WHITE_DARK,		3, 0x0888);	/*  */
		wwc_palette_set_color(FED_COLOR_GREEN_DARK,		3, 0x0080);	/*  */
		wwc_palette_set_color(FED_COLOR_MAGENTA_DARK,	3, 0x0808);	/*  */
		wwc_palette_set_color(FED_COLOR_CYAN_DARK,		3, 0x0088);	/*  */
		wwc_palette_set_color(FED_COLOR_YELLOW_DARK,	3, 0x0880);	/*  */

		/*
		 * XvCgp̃pbgݒ
		 */
		wwc_palette_set_color(FEDORA_COLOR, 0, 0x0000);	/*  */
		wwc_palette_set_color(FEDORA_COLOR, 1, 0x0080);	/* × */
		wwc_palette_set_color(FEDORA_COLOR, 2, 0x01c1);	/*  */
		wwc_palette_set_color(FEDORA_COLOR, 3, 0x03f3);	/*  */

		wwc_palette_set_color(TRILBY_COLOR, 0, 0x0000);	/*  */
		wwc_palette_set_color(TRILBY_COLOR, 1, 0x0808);	/* Î */
		wwc_palette_set_color(TRILBY_COLOR, 2, 0x0c1c);	/*  */
		wwc_palette_set_color(TRILBY_COLOR, 3, 0x0f3f);	/*  */

		wwc_palette_set_color(CANNON_COLOR, 0, 0x0000);	/*  */
		wwc_palette_set_color(CANNON_COLOR, 1, 0x0088);	/* Ð */
		wwc_palette_set_color(CANNON_COLOR, 2, 0x01cc);	/*  */
		wwc_palette_set_color(CANNON_COLOR, 3, 0x03ff);	/*  */
	}

	return 0;
}

int fed_dsp_init_screen()
{
	int mode;

	/* LCD */
	fed_dsp_off();

	/* XN[l */
	screen_set_scroll(SCREEN2, 256 - VIEW_X_OFFSET, 256 - VIEW_Y_OFFSET);
	screen_set_scroll(SCREEN1, 256 - VIEW_X_OFFSET + 1, 256 - VIEW_Y_OFFSET + 1);

	/* XvCǧ 0 ɂ */
	sprite_set_range(0, 0); /* 擪ԍ,  */

	/* pbg */
	fed_dsp_init_palette();

	/* fBXvCݒ */
	/* SPR / SCR2 \ */
	display_control(DCM_SPR | DCM_SCR2);

	/*  */
	fed_dsp_cls();

	mode = lcd_get_segments();
	mode |= LCDSEG_HORIZONTAL;
	lcd_set_segments(mode);

	/* fBXvC_ */
	fed_dsp_on();

	return 0;
}

void fed_dsp_set_color(int x, int y, short c)
{
	static short attr;
/*
@15@14@13@12@11@10@X@W@V@U@T@S@R@Q@P@O

VmHm      palette                  character            

*/
	attr = ((unsigned short)c << 9) | (x*18 + y);
	screen_set_char(SCREEN2, x, y, 1, 1, (short far*)&attr);
	if (c >= 4) {
		/* dark color is original - 4 */
		c -= 4;
	}
	attr = ((unsigned short)c << 9) | (x*18 + y);
	screen_set_char(SCREEN1, x, y, 1, 1, (short far*)&attr);
}

void fed_dsp_put_string(int x, int y, char far *data, int width, int height)
{
	int xn;
	int yn;
	char far *p;

	p = data;
	for (yn = 0; yn < height; yn++) {
		for (xn = 0; xn < width; xn++) {
			ww_put_xor(x+xn*8, y+yn*8, p);
			p = (char far *)((BYTE far *)p + 16);
		}
	}
}

void fed_dsp_put_string_color(int x, int y, char far *data, int width, int height, short c)
{
	int xc;
	int yc;

	int xn;
	int yn;

	fed_dsp_put_string(x, y, data, width, height);

	/* Fݒ */
	xc = x >> 3;
	if ((x & 7) != 0) {
		width++;
	}
	yc = y >> 3;
	if ((y & 7) != 0) {
		height++;
	}
	for (yn = yc; yn < yc+height; yn++) {
		for (xn = xc; xn < xc+width; xn++) {
			fed_dsp_set_color(xn, yn, c);
		}
	}

	return;
}

void fed_dsp_put_num(int x, int y, int n)
{
	char far *data;

	/*  */
	data =  (char far *)((BYTE far *)(s_res_table[RES_BMPID_NUMBER]) + 16 * 10);
	ww_put(x, y, data);
	ww_put_xor(x, y, data);

	/* o */
	data =  (char far *)((BYTE far *)(s_res_table[RES_BMPID_NUMBER]) + 16 * n);
	ww_put(x, y, data);

}

void fed_dsp_put_num3(int x, int y, int n)
{
	/* o */
	/* 1 ̈(Ko) */
	fed_dsp_put_num(x+8, y, n%10);
	if (n >= 10) {
		/* 10 ̈(10ȏ̏ꍇo) */
		fed_dsp_put_num(x+4, y, (n%100)/10);
		if (n >= 100) {
			/* 100 ̈(100ȏ̏ꍇo) */
			fed_dsp_put_num(x, y, n/100);
		}
	}

}

void fed_dsp_put_fedoralogo(int x, int y, short c)
{
	fed_dsp_put_string_color(x,y, s_res_table[RES_BMPID_TITLE],5,1, c);
}

void fed_dsp_put_yasuoka(int x, int y, short c)
{
	fed_dsp_put_string_color(x,y, s_res_table[RES_BMPID_YASUOKA],6,1, c);
}

void fed_dsp_put_hiscore(int hiscore)
{
	int x;
	int y;

	fed_dsp_put_string_color(58,14,s_res_table[RES_BMPID_HISCORE],4,1, FED_COLOR_YELLOW);
	for (y = 1; y < 4; y++) {
		for (x = 11; x < 14; x++) {
			fed_dsp_set_color(x, y, FED_COLOR_YELLOW);
		}
	}
	fed_dsp_put_num3(90, 12, hiscore);
}

void fed_dsp_put_score()
{
	int x;
	int y;

	fed_dsp_put_string_color(63,62,s_res_table[RES_BMPID_SCORE],3,1,FED_COLOR_MAGENTA);
	for (y = 7; y < 9; y++) {
		for (x = 11; x < 14; x++) {
			fed_dsp_set_color(x, y, FED_COLOR_MAGENTA);
		}
	}
	fed_dsp_put_num3(86, 60, 0);
}

void fed_dsp_put_fedora(int x, int y)
{
	ww_put(x,y,s_res_table[RES_BMPID_FEDORA]+64);
}

void fed_dsp_put_keydesc()
{
	/* Move key */
	fed_dsp_put_string(20,68,s_res_table[RES_BMPID_KEYIMG],5,4);
	/* Shot key */
	fed_dsp_put_string(80,80,s_res_table[RES_BMPID_KEYDESC],10,1);
}

void fed_dsp_put_keydesc2()
{
	/* Move key */
	fed_dsp_put_string(20,68,s_res_table[RES_BMPID_KEYIMG2],5,4);
	/* Shot key */
	fed_dsp_put_string(80,80,s_res_table[RES_BMPID_KEYDESC2],10,1);
}

void fed_dsp_put_winning()
{
	fed_dsp_put_string(60,48,s_res_table[RES_BMPID_WINNING],5,1);
}

void fed_dsp_put_gameover()
{
	fed_dsp_put_string(52,48,s_res_table[RES_BMPID_GAMEOVER],7,1);
}

static int s_contrast = 0;

int fed_dsp_get_contrast()
{
	return s_contrast;
}

void fed_dsp_set_contrast(int contrast)
{
	int mode;
	int dspstat;
	mode = lcd_get_segments();
	dspstat = display_status();

	if (contrast == 1) {
		mode |=  LCDSEG_AUX1;
		mode &= ~LCDSEG_AUX2;
		mode &= ~LCDSEG_AUX3;
		dspstat &= ~DCM_SCR1;
	} else if (contrast == 2) {
		mode &= ~LCDSEG_AUX1;
		mode |=  LCDSEG_AUX2;
		mode &= ~LCDSEG_AUX3;
		dspstat |= DCM_SCR1;
	} else if (contrast == 3) {
		mode &= ~LCDSEG_AUX1;
		mode &= ~LCDSEG_AUX2;
		mode |=  LCDSEG_AUX3;
		dspstat |= DCM_SCR1;
	} else {
		mode &= ~LCDSEG_AUX1;
		mode &= ~LCDSEG_AUX2;
		mode &= ~LCDSEG_AUX3;
		dspstat &= ~DCM_SCR1;
	}
	lcd_set_segments(mode);
	display_control(dspstat);

	s_contrast = contrast;
}

int fed_dsp_init_sprite()
{
	unsigned int player_char_no = 511;
	unsigned int cannon_char_no = 510;
	int i;

	/*
	 * tHgLN^̒`
	 */

	/* CLN^ */
	if (s_contrast == 1) {
		font_set_colordata(player_char_no, 1, s_res_table[RES_BMPID_FEDORA]+16);
		font_set_colordata(cannon_char_no, 1, s_res_table[RES_BMPID_CANNON]+16);
	} else if (s_contrast == 2) {
		font_set_colordata(player_char_no, 1, s_res_table[RES_BMPID_FEDORA]+32);
		font_set_colordata(cannon_char_no, 1, s_res_table[RES_BMPID_CANNON]+32);
	} else if (s_contrast == 3) {
		font_set_colordata(player_char_no, 1, s_res_table[RES_BMPID_FEDORA]+48);
		font_set_colordata(cannon_char_no, 1, s_res_table[RES_BMPID_CANNON]+48);
	} else {
		font_set_colordata(player_char_no, 1, s_res_table[RES_BMPID_FEDORA]);
		font_set_colordata(cannon_char_no, 1, s_res_table[RES_BMPID_CANNON]);
	}

	/*
	 * XvCg̒`
	 */
	/* FEDORA(1) */
	sprite_set_char(0, ((FEDORA_COLOR - 8)<<9) | player_char_no); /* no, attrs | char no */
	sprite_set_location(0, 224, 224); /* no, x, y */
	/* TRILBY(4) */
	for (i = 0; i < 4; i++) {
		sprite_set_char(i+1, ((TRILBY_COLOR - 8)<<9) | player_char_no); /* no, attrs | char no */
		sprite_set_location(i+1, 224, 224); /* no, x, y */
	}
	for (i = 0; i < 32; i++) {
		sprite_set_char(i+5, ((CANNON_COLOR - 8)<<9) | cannon_char_no); /* no, attrs | char no */
		sprite_set_location(i+5, 224, 224); /* no, x, y */
	}
	sprite_set_range(0, 1+4+32); /* 擪ԍ,  */

}

void fed_dsp_put_game_screen()
{
	/* LCD  */
	fed_dsp_off();

	/* XvCg̏ */
	fed_dsp_init_sprite();

	/*  */
	fed_dsp_cls();

	/*  */
	fed_dsp_line(1,3, 158,3);

	/* E */
	fed_dsp_line(158,3, 158,96);

	/*  */
	fed_dsp_line(1,96, 158,96);

	/*  */
	fed_dsp_line(1,3, 1,96);

	/* LCD _ */
	fed_dsp_on();
}

void fed_dsp_hide_fedorasprite()
{
	sprite_set_location(0, 224, 224);
}

void fed_dsp_move_fedorasprite(int x, int y)
{
	sprite_set_location(0, VIEW_X_OFFSET + x - 1, VIEW_Y_OFFSET + y - 1);
}

void fed_dsp_hide_trilbysprite(int n)
{
	sprite_set_location(n+1, 224, 224);
}

void fed_dsp_move_trilbysprite(int n, int x, int y)
{
	sprite_set_location(n+1, VIEW_X_OFFSET + x - 1, VIEW_Y_OFFSET + y - 1);
}

void fed_dsp_hide_cannonsprite(int n)
{
	sprite_set_location(n+5, 224, 224);
}

void fed_dsp_move_cannonsprite(int n, int x, int y)
{
	sprite_set_location(n+5, VIEW_X_OFFSET + x - 2, VIEW_Y_OFFSET + y - 2);
}

int fed_dsp_bmpsaver()
{
	static int s_bmpil_loaded = 0;

	/* BMPSaver IL  */
	if (!s_bmpil_loaded) {
		if (ilibIL->_open("@bmpsaver", (IL far *)&bsvIL) == E_FS_SUCCESS) {
			s_bmpil_loaded = 1;
		}
	}

	if (s_bmpil_loaded) {
		/* ʃLv` */
		int dspstat;
		int target;
		target = 0;
		dspstat = display_status();
		if (dspstat & DCM_SCR1) {
			target |= KH_BS_SCREEN1;
		}
		if (dspstat & DCM_SCR2) {
			target |= KH_BS_SCREEN2;
		}
		if (dspstat & DCM_SPR) {
			target |= KH_BS_SPRITE;
			bs_sprite_set_range(0, 1+4+32);
		}
		bs_set_target(target);
		if (wwc_get_hardarch() == HARDARCH_WS){
			if (bs_save_screen_xmodem("bmpsaver.bmp",0,0, LCD_PIXEL_WIDTH,LCD_PIXEL_HEIGHT) != KH_BS_OK){
				return -1;
			}
		} else {
			if (bsc_save_screen_xmodem("bmpsaver.bmp",0,0, LCD_PIXEL_WIDTH,LCD_PIXEL_HEIGHT) != KH_BS_OK){
				return -1;
			}
		}
	}

	return 0;
}
