/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#ifndef _DISPLAY_H_INCLUDED_
#define _DISPLAY_H_INCLUDED_

/* Color 0 is transtarent at palette 4`7 and 12`15 */

/* original color */
#define FED_COLOR_SCREEN2	4
#define FED_COLOR_SCREEN1	5

#define FED_COLOR_WHITE		7
#define FED_COLOR_YELLOW	12
#define FED_COLOR_CYAN		13
#define FED_COLOR_MAGENTA	14
#define FED_COLOR_GREEN		15

/* dark color must be original - 4 */
#define FED_COLOR_SCREEN2_DARK	0
#define FED_COLOR_SCREEN1_DARK	1

#define FED_COLOR_WHITE_DARK	3
#define FED_COLOR_YELLOW_DARK	8
#define FED_COLOR_CYAN_DARK		9
#define FED_COLOR_MAGENTA_DARK	10
#define FED_COLOR_GREEN_DARK	11

/* Sprites must use 8`15 */
#define CANNON_COLOR		FED_COLOR_CYAN
#define TRILBY_COLOR		FED_COLOR_MAGENTA
#define FEDORA_COLOR		FED_COLOR_GREEN

int fed_dsp_load_resources();
int fed_dsp_init_palette();
int fed_dsp_init_screen();
int fed_dsp_init_sprite();

void fed_dsp_on();
void fed_dsp_off();

void fed_dsp_cls();

void fed_dsp_line(int x1, int y1, int x2, int y2);

int fed_dsp_get_contrast();
void fed_dsp_set_contrast(int contrast);

void fed_dsp_set_color(int x, int y, short c);
void fed_dsp_put_string(int x, int y, char far *data, int width, int height);
void fed_dsp_put_string_color(int x, int y, char far *data, int width, int height, short c);
void fed_dsp_put_num(int x, int y, int n);
void fed_dsp_put_num3(int x, int y, int n);

void fed_dsp_put_fedoralogo(int x, int y, short c);
void fed_dsp_put_yasuoka(int x, int y, short c);
void fed_dsp_put_hiscore(int hiscore);
void fed_dsp_put_score();
void fed_dsp_put_fedora(int x, int y);
void fed_dsp_put_keydesc();
void fed_dsp_put_keydesc2();
void fed_dsp_put_winning();
void fed_dsp_put_gameover();

void fed_dsp_put_game_screen();

void fed_dsp_hide_fedorasprite();
void fed_dsp_move_fedorasprite(int x, int y);
void fed_dsp_hide_trilbysprite(int n);
void fed_dsp_move_trilbysprite(int n, int x, int y);
void fed_dsp_hide_cannonsprite(int n);
void fed_dsp_move_cannonsprite(int n, int x, int y);

int fed_dsp_bmpsaver();

#endif
