/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#include <sys/timer.h>
#include <sys/system.h>

#include "wwhook.h"

#if defined(LSI_C_WW)
extern unsigned _asm_inline();
#define _CS _asm_inline("mov ax, cs")
#define _DS _asm_inline("mov ax, ds")
#endif

void ww_set_hook(int type, void (far *callback)())
{
	static intvector_t v;
	unsigned int cs_reg;
	unsigned int ds_reg;

#if defined(__DMC__)
	asm {
		mov cs_reg, cs
		mov ds_reg, ds
	}
#elif defined(LSI_C_WW) || defined(__TURBOC__)
	cs_reg = _CS;
	ds_reg = _DS;
#else
	#error "I don't know how to read CS & DS."
#endif
	v.callback = (void (near *)())callback;
	v.cs = cs_reg;
	v.ds = ds_reg;
	sys_interrupt_set_hook(type, &v, NULL);
}

void ww_enable_hook(int type)
{
	timer_enable(type, TIMER_AUTOPRESET, 1);
}

void ww_disable_hook(int type)
{
	timer_disable(type);
}
