/*
 * Copyright (C) 2003 wwcube (wwcube@yahoo.co.jp)
 */

#include <sys/sound.h>

#include "wwsound.h"

void ww_play_sound_volume(int volume)
{
	volume &= 0xf;
	volume |= (volume << 4);
	sound_set_pitch(0, DEFAULT_PITCH);
	sound_set_volume(0, volume);
}

void ww_change_sound_pitch(int pitch)
{
	sound_set_pitch(0, pitch);
}

void ww_change_sound_volume(int volume)
{
	volume &= 0xf;
	volume |= (volume << 4);
	sound_set_volume(0, volume);
}

void ww_play_sound()
{
	sound_set_pitch(0, DEFAULT_PITCH);
	sound_set_volume(0, 0xff);
}

void ww_stop_sound()
{
	sound_set_volume(0, 0x00);
	sound_set_pitch(0, DEFAULT_PITCH);
}

int ww_init_sound()
{
	unsigned int state;

	/*
	 * TEh
	 */
	static unsigned char wv[] = {
		0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00,
		0x88,0x88,0x88,0x88,0x88,0x88,0x88,0x88,
	};

	/*  */
	sound_init();

	/* `l̎gp@ݒ */
	sound_set_channel(1);	/* `lP ON */

	/*
	 * `l̏o͕@w
	 *  7  6  5  4  3  2  1  0
	 * +--+--+--+--+--+--+--+--+
	 * | 0| 0| 0| 0|HP| Vol |SP|
	 * +--+--+--+--+--+--+--+--+
	 */
	sound_set_output(0x09);

	/* g`f[^ݒ */
	sound_set_wave(0, wv);	/* `l1ɔg`ݒ */

	/* ʂݒ */
	sound_set_volume(0, 0x00);

	/*
	 * gݒ
	 *
	 * freq = 3.072 x 10^6 / ((2048 - N) x 32)
	 * freq = 1200
	 * (2048 - N) x 32 = 3072000/1200
	 * 2048 - N = 3072000/(1200 x 32)
	 * N = 2048 - 3072000/(1200 x 32) = 2048 - 80 = 1968
	 *
	 * freq = 2400, N = 2008
	 */
	 sound_set_pitch(0, DEFAULT_PITCH);

	return 0;
}

